﻿using System;
using System.Collections.Generic;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            Console.Title = "너비 우선 탐색을 사용해 최단 경로 구하기";

            List<Student> vertexList = Student.GetList(10);

            List<Tuple<Student, Student>> edgeList = new List<Tuple<Student, Student>>
            {
                Tuple.Create(vertexList[0], vertexList[1]),
                Tuple.Create(vertexList[0], vertexList[2]),
                Tuple.Create(vertexList[1], vertexList[3]),
                Tuple.Create(vertexList[2], vertexList[4]),
                Tuple.Create(vertexList[2], vertexList[5]),
                Tuple.Create(vertexList[3], vertexList[6]),
                Tuple.Create(vertexList[4], vertexList[6]),
                Tuple.Create(vertexList[4], vertexList[7]),
                Tuple.Create(vertexList[4], vertexList[5]),
                Tuple.Create(vertexList[7], vertexList[8]),
                Tuple.Create(vertexList[8], vertexList[9])                
            };

            Graph<Student> graph = new Graph<Student>(vertexList, edgeList);

            Student startVertex = vertexList[0];

            Func<Student, IEnumerable<Student>> shortestPathFunc = GraphHelper.GetShortestPathFunction<Student>(graph, startVertex);

            foreach(Student vertex in vertexList)
            {
                Console.WriteLine("학번 : {0}, 성명 : {1}", vertex.ID, vertex.Name);

                IEnumerable<Student> visitEnumerable = shortestPathFunc(vertex);

                foreach(Student visitVertex in visitEnumerable)
                {
                    Console.WriteLine("    학번 : {0}, 성명 : {1}", visitVertex.ID, visitVertex.Name);
                }

                Console.WriteLine();
            }
        }

        #endregion
    }
}